<?php
/*
  $Id: abxProfiles.php,v 1.13 2007/01/03 02:00:14 auctionblox Exp $

  AuctionBlox, sell more, work less!

  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  class abxProfiles {

    function invalidate() {
    }

    function getProfiles() {
      $response = abxAPI::call('profile.getProfiles');
      return $response['profiles'];
    }

    function getProfileById($nProfileId) {
      $profiles = abxProfiles::getProfiles();
      foreach($profiles as $profile) {
        if($nProfileId == $profile['id'])
           return $profile;
      }
    }

    function save(&$aPost) {
      global $messageStack;

      $aArr = array(
        'id'           => $aPost['oID'],
        'label'        => $aPost['label'],
        'send_wbn'     => ($aPost['sendWBN'] == 'on' ? 1 : 0),
        'from_address' => $aPost['fromAddress'],
        'bcc_address'  => $aPost['bccAddress'],
        'html_email'   => ($aPost['htmlEmail'] == 'on' ? 1 : 0)
      );

      $aResult = abxAPI::call('profile.saveProfile', $aArr);
      if (abxAPI::isError($aResult)) {
        $messageStack->add_session(ERROR_TEXT_REQUEST_FAILED, 'error');
      }
    }

    function delete($aProfiles) {
      global $messageStack;

      if (!is_array($aProfiles)) {
        $aProfiles = array($aProfiles);
      }

      $bError = false;
      foreach($aProfiles as $nProfile) {
        $aArr = array('id' => $nProfile);

        $aResult = abxAPI::call('profile.removeProfile', $aArr);

        if (abxAPI::isError($aResult)) {
          $bError = true;
        }
      }

      if ($bError) {
        $messageStack->add_session(ERROR_TEXT_REQUEST_FAILED,'error');
      }
    }
  }//end class
?>