<?php
/*
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

// Define the webserver and path parameters
// * DIR_FS_* = Filesystem directories (local/physical)
// * DIR_WS_* = Webserver directories (virtual/URL)
  define('HTTP_SERVER', 'http://www.YOUR_DOMAIN_NAME.com'); // ie: http://www.autoload.org - should not be empty for productive servers
  define('HTTP_CATALOG_SERVER', '');
  define('HTTPS_CATALOG_SERVER', '');
  define('ENABLE_SSL_CATALOG', 'false'); // secure webserver for catalog module
  define('DIR_FS_DOCUMENT_ROOT', $DOCUMENT_ROOT); // where your pages are located on the server. if $DOCUMENT_ROOT doesnt suit you, replace with your local path on the server. (ie: /usr/local/apache/htdocs)
  define('DIR_WS_ADMIN', '/admin/'); // default is /admin/
  define('DIR_FS_ADMIN', DIR_FS_DOCUMENT_ROOT . DIR_WS_ADMIN); // default is DIR_FS_DOCUMENT_ROOT . DIR_WS_ADMIN but could be changed to use a local path on the server
  define('DIR_WS_CATALOG', '/'); // default is /
  define('DIR_FS_CATALOG', DIR_FS_DOCUMENT_ROOT . DIR_WS_CATALOG); // default is DIR_FS_DOCUMENT_ROOT . DIR_WS_CATALOG but could be changed to use a local path on the server
  define('DIR_WS_IMAGES', 'images/'); // default is images/
  define('DIR_WS_ICONS', DIR_WS_IMAGES . 'icons/'); // default is icons/
  define('DIR_WS_CATALOG_IMAGES', DIR_WS_CATALOG . 'images/'); // default is images/
  define('DIR_WS_INCLUDES', 'includes/'); // default is includes/
  define('DIR_WS_BOXES', DIR_WS_INCLUDES . 'boxes/'); // default is boxes/
  define('DIR_WS_FUNCTIONS', DIR_WS_INCLUDES . 'functions/'); // default is functions/
  define('DIR_WS_CLASSES', DIR_WS_INCLUDES . 'classes/'); // default is classes/
  define('DIR_WS_MODULES', DIR_WS_INCLUDES . 'modules/'); // default is modules/
  define('DIR_WS_LANGUAGES', DIR_WS_INCLUDES . 'languages/'); // default is languages/
  define('DIR_WS_CATALOG_LANGUAGES', DIR_WS_CATALOG . 'includes/languages/'); // default is includes/languages/
  define('DIR_FS_CATALOG_LANGUAGES', DIR_FS_CATALOG . 'includes/languages/'); // default is includes/languages/
  define('DIR_FS_CATALOG_IMAGES', DIR_FS_CATALOG . 'images/'); // default is images/
  define('DIR_FS_CATALOG_MODULES', DIR_FS_CATALOG . 'includes/modules/'); // default is includes/modules/
  define('DIR_FS_BACKUP', DIR_FS_ADMIN . 'backups/'); // default is backups/

// Database Connection Configuration below
// define our database connection
  define('DB_SERVER', 'Your database server'); // ie: localhost - should not be empty for productive servers
  define('DB_DATABASE', 'Your database name here');  // enter your database name here.  ie: mydatabase1
  define('DB_SERVER_USERNAME', 'Your database username');  // enter your database name here.  ie: myusername
  define('DB_SERVER_PASSWORD', 'Your database password');  // enter your database name here.  ie: mysecretpassword
  define('USE_PCONNECT', 'false'); // use persistent connections?  default is false
  define('STORE_SESSIONS', 'mysql'); // leave empty '' for default handler or set to 'mysql' default is mysql
?>