<?php
/*
  $Id: listings_failed.php,v 1.3 2006/01/28 22:14:17 auctionblox Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  if (class_exists('abxPaginator_Listings') === false) {

    require_once(DIR_FS_ABX_PAGINATORS . 'listings.php');

  }

  class abxPaginator_Listings_Failed extends abxPaginator_Listings {

    function sortDefaultArray()
    {
      return array(
        'name'  => 'id',
        'value' => 'desc'
      );
    }

    function tableDataHeadings()
    {
      return array(
        array('heading' => HEADING_LISTING_TITLE, 'sort_field' => 'ext_title'),
        array('heading' => HEADING_LISTING_SITE, 'sort_field' => 'site'),
        array('heading' => HEADING_LISTING_TYPE, 'sort_field' => 'listing_type'),
        array('heading' => HEADING_LISTING_ERROR)
      );
    }

    function tableDataRowContents($array)
    {
      global $currencies;

      $listingTypes = abxConstants::getListingTypesShort();

      return '<td>' . $this->cellWrap($array['ext_title'],150) . '</td>'.
             '<td>' . $this->cell($array['site']) . '</td>'.
             '<td>' . $this->cell($listingTypes[$array['listing_type']]) . '</td>'.
             '<td>' . $this->cellWrap(htmlentities($array['error_text']),150) . '</td>';
    }
    
    function bulkActions()
    {
      return array(
        'DeleteItems'    => array('icon'=>'delete.gif','alt'=>ACTION_DELETE,'onclick' => "confirmBulkAction('".JAVASCRIPT_CONFIRM_DELETE."','".TEXT_LISTINGS."','DeleteConfirm');"),
        'RelistListings' => array('icon'=>'uploads.gif','alt'=>ACTION_RELIST,'action'=>'scheduler'),
        'CancelListings' => array('icon'=>'cancel.gif','alt'=>ACTION_CANCEL_LISTINGS,'onclick' => "confirmBulkAction('".JAVASCRIPT_CONFIRM_CANCEL."','".TEXT_LISTINGS."','CancelListings','uploader','abx_uploader');")
      );
    }

    function singleActions($array = array())
    {
      return array(
        'EditSale' => array('enabled' => 'false','icon'=>'edit.gif','alt'=>TEXT_EDIT_LISTING,'url'=>abx_href_link(FILENAME_AUCTIONBLOX, 'abx=items-edit&itemID=' . $array['item_uuid'] . '&listing_uuid='. $array['uuid'].abxPage::getSearchParams())),
      );
    }

  }//end class
?>